<?php

class TransferCalc
{

    public static $digits = ["B", "KiB", "MiB", "GiB"];
    // Bの場合は0指定、GiBなので3指定
    public static $min_digits_pos = 3;

    public static function transformDigit( $work, $count = 0)
    {
        if ($count >= count(self::$digits)) {
            $val = self::floorDecimalPlace($work);

            return $val . " " .self::$digits[$count - 1];

        }

        if ($work > 1024 || $count <= self::$min_digits_pos) {
            return self::transformDigit((float) $work / 1024, $count + 1);
        } else {
            $val = self::floorDecimalPlace($work);

            return $val . " " .self::$digits[$count - 1];
        }
    }

    public static function floorDecimalPlace($number) {
        return (float) ((int) ($number * 10) / 10);
    }
}