<?php

?>

<div class="wrap" id="imageflux">
    <h1>ImageFlux基本設定</h1>

    <h2>オリジン編集</h2>
    <form action="" method='post' id="origin-form">
        <?php wp_nonce_field(self::CREDENTIAL_ACTION_UPDATE_BASIC, self::CREDENTIAL_NAME_UPDATE_BASIC) ?>
        <?php if (($completed_message = get_transient(self::COMPLETE_CONFIG)) !== false) : ?>
            <div class="updated"><p><strong><?php echo esc_html($completed_message) ?></strong></p></div>
        <?php endif; ?>
        <?php if (($error_message = get_transient(self::ERROR_CONFIG)) !== false) : ?>
            <div class="error"><p><strong><?php echo esc_html($error_message) ?></strong></p></div>
        <?php endif; ?>
        <input type="hidden" name="origin_id" value="<?php echo esc_attr((int)$origin_id) ?>"
        <p>
            <label for="api_token">APIトークン：</label>
            <input type="text" id="api_token" name="api_token" data-name="APIトークン" value="<?php echo esc_attr($basic->get('api_token')) ?>" style="width: 800px;" disabled />
        </p>
        <p>
            <label for="kind_http">オリジン種別：</label>
            <input type="radio" name="kind" value="0" id="kind_http" <?php if ((int)$response['origin']['kind'] === 0): ?> checked <?php endif; ?> required> HTTP
            <input type="radio" name="kind" value="1" id="kind_s3" <?php if ((int)$response['origin']['kind'] === 1): ?> checked <?php endif; ?> required> S3
        </p>

        <div id="http_configs" <?php if ((int)$response['origin']['kind'] !== 0): ?> style="display: none;" <?php endif; ?>>
            <p>
                <label for="scheme">スキーム：</label>
                <select name="scheme" id="scheme" data-name="スキーム">
                    <?php foreach (['http', 'https'] as $value) { ?>
                        <option value="<?php echo esc_attr($value) ?>" <?php if ($response['origin']['config']['scheme'] ?? 'http' === $value): ?> selected <?php endif; ?>><?php echo esc_html($value) ?></option>
                    <?php } ?>
                </select>
            </p>
            <p>
                <label for="host_name">ホスト：</label>
                <input type="text" id="host_name" name="host_name" data-name="ホスト" value="<?php echo esc_attr($response['origin']['config']['host'] ?? '') ?>" placeholder="example.com"/>
            </p>
        </div>
        <div id="s3_configs" <?php if ((int)$response['origin']['kind'] !== 1): ?> style="display: none;" <?php endif; ?>>
            <p>
                <label for="access_key_id">AWSアクセスキーID：</label>
                <input type="text" id="access_key_id" data-name="AWSアクセスキーID" name="access_key_id" value="<?php echo esc_attr($response['origin']['config']['accessKeyID'] ?? "") ?>" placeholder=""/>
            </p>
            <p>
                <label for="secret_access_key">AWSシークレットアクセスキー：</label>
                <input type="text" id="secret_access_key" data-name="AWSシークレットアクセスキー" name="secret_access_key" value="<?php echo esc_attr($response['origin']['config']['secretAccessKey'] ?? "") ?>" placeholder=""/>
            </p>
            <p>
                <label for="region">AWSリージョン：</label>
                <input type="text" id="region" name="region" data-name="AWSリージョン" value="<?php echo esc_attr($response['origin']['config']['region'] ?? "") ?>" placeholder=""/>
            </p>
            <p>
                <label for="bucket">AWSバケット：</label>
                <input type="text" id="bucket" name="bucket" data-name="AWSバケット" value="<?php echo esc_attr($response['origin']['config']['bucket'] ?? "") ?>" placeholder=""/>
            </p>
            <p>
                <label for="path_prefix">エンドポイント：</label>
                <input type="text" id="end_point" name="end_point"  placeholder="" value="<?php echo esc_attr($basic->get('end_point')) ?>"/>
            </p>
        </div>

        <p>
            <label for="path_prefix">パスプレフィックス：</label>
            <input type="text" id="path_prefix" name="path_prefix" value="<?php echo esc_attr($response['origin']['config']['pathPrefix'] ?? "/") ?>" placeholder="/"/>
        </p>
        <p>
            <label for="enable_signed_url">署名付きURL：</label>
            <input type="hidden" name="enable_signed_url" value="1">
            <input type="checkbox" id="enable_signed_url_1" name="enable_signed_url" value="1" <?php if ($response['origin']['enableSignedUrl']) { echo "checked"; } ?>>
            <label for="enable_signed_url_1">有効</label>
        </p>
        <p>
            <label for="signing_secret">署名付きURL使用時の暗号化鍵：</label>
            <input type="text" id="signing_secret" name="signing_secret" value="<?php echo esc_attr($response['origin']['signingSecret']) ?>" placeholder=""/>
        </p>

        <p><input type='submit' value='保存' class='button button-primary button-large'></p>
    </form>
</div>

<script>
    jQuery('input[name="kind"]').on('change', function () {
        let val = parseInt(jQuery(this).val());

        // HTTP
        if (val === 0) {
            jQuery('#s3_configs').hide();
            jQuery('#http_configs').show();
        }
        // S3
        if (val === 1) {
            jQuery('#http_configs').hide();
            jQuery('#s3_configs').show();
        }
    });

    jQuery('input[name="enable_signed_url"]').on('change', function() {
        let val = jQuery(this).prop('checked');

        jQuery('input[name="enable_signed_url"]').val(val ? 1 : 0);
    });

    // バリデーション
    jQuery('#origin-form').on('submit', function () {
        let all_required_keys = ['api_token'];
        let http_required_keys = ['scheme', 'host_name'];
        let s3_required_keys = ['access_key_id', 'secret_access_key', 'region', 'bucket'];

        let errors = [];

        let kind = parseInt(jQuery('input[name="kind"]:checked').val());

        // 全体
        jQuery.each(all_required_keys, function (index, key) {
            if (isValueEmpty(key)) {
                errors.push(jQuery('#' + key).data('name') + "は必須です。\n");
            }
        });

        // HTTP
        if (kind === 0) {
            jQuery.each(http_required_keys, function (index, key) {
                if (isValueEmpty(key)) {
                    errors.push("種別がHTTPのとき、" + jQuery('#' + key).data('name') + "は必須です。\n");
                }
            });
        }

        // S3
        if (kind === 1) {
            jQuery.each(s3_required_keys, function (index, key) {
                if (isValueEmpty(key)) {
                    errors.push("種別がS3のとき、" + jQuery('#' + key).data('name') + "は必須です。\n");
                }
            });
        }

        let checked = jQuery('#enable_signed_url_1').prop('checked');
        if (checked) {
            if (isValueEmpty('signing_secret')) {
                errors.push('署名付きURLを有効にするとき、暗号化鍵を設定してください。')
            }
        }

        if (errors.length > 0) {
            alert(errors.join(""));
            return false;
        }
    });

    function isValueEmpty(id)
    {
        return jQuery('#' + id).val() === "";
    }

</script>