<?php

?>

<div class="wrap dashboard" id="imageflux">
    <h1>ダッシュボード</h1>

    <table>
        <thead>
        <tr>
            <th></th>
            <th>リクエスト(回)</th>
            <th>画像変換回数(回)</th>
            <th>転送量</th>
            <th>キャッシュヒット率(%)</th>
        </tr>
        </thead>
        <tbody>
        <?php
        $str_month = ["当月", "前月", "前々月"];
        $month_index = 0;

        $unit_list = ['B', 'KiB', 'MiB', 'GiB'];
        ?>

        <?php foreach (array_reverse($transfer_view_datas) as $transfer_view_data) { ?>
            <tr>
                <td><?php echo esc_html($str_month[$month_index++]) ?></td>
                <td><?php echo esc_html($transfer_view_data['requests']) ?></td>
                <td><?php echo esc_html($transfer_view_data['miss']) ?></td>
                <td><?php echo esc_html($transfer_view_data['outboundBytes']) ?></td>
                <td><?php echo esc_html($transfer_view_data['per_hits']) ?> %</td>
            </tr>
        <?php } ?>
        </tbody>
    </table>

    <div style="width:80%; margin: 20px 0;">
        <canvas id="request-bar-stack">
        </canvas>
    </div>

    <div style="width:80%; margin: 20px 0;">
        <canvas id="outbound-bar-stack">
        </canvas>
    </div>
</div>

<script src="<?php echo esc_url(plugins_url( '../js/chart.min.js', __FILE__ )); ?>"></script>
<script>

    var ctx = document.getElementById('request-bar-stack');
    var myChart1 = new Chart(ctx, {
        data: {
            datasets: [
                {
                    type: 'line',
                    label: '転送量',
                    data: <?php echo json_encode($transfer_view_datas[$graph_month]['day']['outboundBytes']) ?>,
                    pointBackgroundColor: '#111111',
                    backgroundColor: '#111111',
                    borderColor: '#111111',
                    stack: 'stack-2',
                    yAxisID: 'y2',
                    borderWidth: 3,
                },
                {
                    type: 'bar',
                    label: 'キャッシュヒット数',
                    data: <?php echo json_encode($transfer_view_datas[$graph_month]['day']['hits']) ?>,
                    backgroundColor: '#447AF2',
                    stack: 'stack-1',
                }, {
                    type: 'bar',
                    label: '画像変換回数',
                    data: <?php echo json_encode($transfer_view_datas[$graph_month]['day']['miss']) ?>,
                    backgroundColor: '#FF445B',
                    stack: 'stack-1',
                }],
        },
        options: {
            scales: {
                y: {
                    position: 'left',
                    ticks: {
                        beginAtZero: true,
                        callback: function (label, index, labels) {
                            return label + "回";
                        }
                    },
                },
                y2: {
                    position: 'right',
                    ticks: {
                        beginAtZero: true,
                        callback: function (label, index, labels) {
                            return transformDigit(parseInt(label));
                        }
                    },
                },
            },
        }
    });

    function transformDigit(work, count = 0) {
        var digits = ["B", "KiB", "MiB", "GiB", "TiB"];

        if (count >= digits.length - 1) {
            return floorDecimalPlace(work) + " " + digits[digits.length - 1];
        }

        if (work > 1024) {
            return transformDigit(work / 1024, count + 1);
        } else {
            return floorDecimalPlace(work) + " " + digits[count];
        }
    }

    function floorDecimalPlace(number) {
        return Math.floor(number * 10) / 10;
    }
</script>