<?php

?>

<div class="wrap" id="imageflux">
    <h1>画像変換・配信設定</h1>

    <form action="" method='post' id="my-submenu-form">
        <?php wp_nonce_field(self::CREDENTIAL_ACTION_DIFF, self::CREDENTIAL_NAME_DIFF) ?>
        <?php if (($completed_message = get_transient(self::COMPLETE_CONFIG)) !== false) : ?>
            <div class="updated"><p><strong><?php echo esc_html($completed_message) ?></strong></p></div>
        <?php endif; ?>
        <p>
            <label for="format">フォーマット変換：</label>
            <select name="format" id="format">
                <?php foreach (['auto', 'jpg', 'png', 'gif', 'webp', 'webp:auto', 'webp:jpg', 'webp:png', 'webp:gif'] as $value) { ?>
                    <option value="<?php echo esc_attr($value); ?>" <?php if ((is_null($diff->get('format')) ? 'auto' : $diff->get('format')) === $value): ?> selected <?php endif; ?>><?php echo esc_html($value); ?></option>
                <?php } ?>
            </select>
        </p>
        <p>
            <label for="stream_not_allow_extensions">配信しない拡張子の指定：</label>
            <label style="margin-left:2px;">
                jpeg:
                <input type="hidden" id="allow_extension_jpeg" name="allow_extension_jpeg" value="0">
                <input type="checkbox" id="allow_extension_jpeg" name="allow_extension_jpeg" value="1"
                <?php if ((int) $diff->get('allow_extension_jpeg') === 1) { echo esc_attr("checked"); } ?> >
            </label>
            <label style="margin-left:10px;">
                png:
                <input type="hidden" id="allow_extension_jpeg" name="allow_extension_png" value="0">
            <input type="checkbox" id="allow_extension_png" name="allow_extension_png" value="1"
                <?php if ((int) $diff->get('allow_extension_png') === 1) { echo esc_attr("checked"); } ?> >
            </label>
            <label style="margin-left:10px;">
                gif:
                <input type="hidden" id="allow_extension_jpeg" name="allow_extension_gif" value="0">
            <input type="checkbox" id="allow_extension_gif" name="allow_extension_gif" value="1"
                <?php if ((int) $diff->get('allow_extension_gif') === 1) { echo esc_attr("checked"); } ?> >
            </label>
        </p>
        <p>
            <label for="is_auto_resize">端末に応じた画像サイズに自動変換：</label>
            <select name="is_auto_resize" id="is_auto_resize">
                <?php foreach ([0 => "しない", 1 => "する",] as $key => $value) { ?>
                    <option value="<?php echo esc_attr($key) ?>" <?php if ((is_null($diff->get('is_auto_resize')) ? 1 : (int)$diff->get('is_auto_resize')) === $key): ?> selected <?php endif; ?>><?php echo esc_html($value) ?></option>
                <?php } ?>
            </select>
        </p>
        <p>
            <label for="quality">クオリティ指定：</label>
            <input type="number" id="quality" name="quality"
                   value="<?php echo esc_attr(is_null($diff->get('quality')) ? 0 : (int)$diff->get('quality')) ?>" min="0" max="100"/>
        </p>
        <p>
            <label for="exif">Exif削除(JPEGの場合のみ)：</label>
            <select name="exif" id="exif">
                <?php foreach ([1 => "Exif情報を削除する", 2 => "Exif情報のうち、Orientation以外を削除する",] as $key => $value) { ?>
                    <option value="<?php echo esc_attr($key) ?>" <?php if ((is_null($diff->get('exif')) ? 1 : (int)$diff->get('exif')) === $key): ?> selected <?php endif; ?>><?php echo esc_html($value) ?></option>
                <?php } ?>
            </select>
        </p>

        <p><input type='submit' value='保存' class='button button-primary button-large'></p>
    </form>
</div>