<?php

?>

<div class="wrap" id="imageflux">
    <h1>オリジン設定</h1>

    <form id="origin-list" method="post" action="">

        <?php if (($completed_message = get_transient(self::COMPLETE_CONFIG)) !== false) : ?>
            <div class="updated"><p><strong><?php echo esc_html($completed_message) ?></strong></p></div>
        <?php endif; ?>
        <?php if (($error_message = get_transient(self::ERROR_CONFIG)) !== false) : ?>
            <div class="error"><p><strong><?php echo esc_html($error_message) ?></strong></p></div>
        <?php endif; ?>
        <input type="hidden" name="select-origin-id" id="select-origin-id" value="">

        <a href="?page=image-flux-list&origin_id=0">
            <button type="button" style="margin-bottom:8px;">オリジンを追加</button>
        </a>
    <table>
        <thead>
            <tr>
                <td>状態</td>
                <th>ID</th>
                <th>種別</th>
                <th>ホスト名(HTTP)</th>
                <th>バケット名(S3)</th>
                <th>オリジン名</th>
                <th>署名付きURL</th>
                <th></th>
                <th></th>
            </tr>
        </thead>
        <tbody>
        <?php
            foreach ($origin_list as $index => $origin) {
         ?>
                <?php $use_flag = (int)$origin_option->get('origin_id') === $origin['originID']; ?>
                <tr <?php
                        if ($use_flag) {
                            echo esc_attr("style=background-color:#ddddff;");
                        }
                     ?>>
                    <td><?php
                        if ($use_flag) {
                            echo esc_html("使用中");
                        } else {
                            echo esc_html("-");
                        }?>
                    </td>
                    <td><?php echo esc_html($origin['originID']) ?></td>
                    <td><?php
                        if ($origin['kind'] === 0) {
                            echo esc_html("HTTP");
                        } else if ($origin['kind'] === 1) {
                            echo esc_html("S3");
                        } else if ($origin['kind'] === 101) {
                            echo esc_html("Live");
                        }
                        ?></td>
                    <td><?php echo esc_html($origin['config']['host'] ?? ""); ?></td>
                    <td><?php echo esc_html($origin['config']['bucket'] ?? ""); ?></td>
                    <td><?php echo esc_html($origin['originName']['originName']) ?></td>
                    <td><?php
                        if ($origin['enableSignedUrl']) {
                            echo esc_html('有効');
                        } else {
                            echo esc_html('無効');
                        }
                        ?></td>
                    <td style="min-width: 30px;">
                        <?php if (!$use_flag) { ?>
                        <button type="button" name="btn-select-origin" data-origin-id="<?php echo esc_attr($origin['originID']) ?>">使用する</button>
                        <?php } ?>
                    </td>
                    <td style="min-width: 30px;">
                        <a href="?page=image-flux-list&origin_id=<?php echo esc_attr($origin['originID']) ?>">
                            <button type="button">編集</button>
                        </a>
                    </td>
                    <td style="min-width: 30px;">
                        <?php if (!$use_flag) { ?>
                        <button type="button" name="btn-delete-origin" data-origin-id="<?php echo esc_attr($origin['originID']) ?>">削除</button>
                        <?php } ?>
                    </td>
                </tr>
        <?php
            }
         ?>
        </tbody>
    </table>
    </form>
</div>

<script>
    jQuery('button[name="btn-select-origin"]').on('click', function () {
        jQuery("#origin-list").append('<?php wp_nonce_field(self::CREDENTIAL_ACTION_ORIGIN_SELECT, self::CREDENTIAL_NAME_ORIGIN_SELECT) ?>');
        jQuery("#select-origin-id").val(jQuery(this).attr('data-origin-id'));
        jQuery("#origin-list").submit();
    });

    jQuery('button[name="btn-delete-origin"]').on('click', function () {
        let origin_id = jQuery(this).attr('data-origin-id');
        if (confirm("ID:" + origin_id + "のオリジンを削除します。よろしいですか？")) {
            jQuery("#origin-list").append('<?php wp_nonce_field(self::CREDENTIAL_ACTION_ORIGIN_DELETE, self::CREDENTIAL_NAME_ORIGIN_DELETE) ?>');
            jQuery("#select-origin-id").val(origin_id);
            jQuery("#origin-list").submit();
        }
    });
</script>