<?php

?>

<div class="wrap" id="imageflux">
    <h1>ImageFlux</h1>

    <form action="" method='post' id="origin-form">
        <?php wp_nonce_field(self::CREDENTIAL_ACTION_TOKEN, self::CREDENTIAL_NAME_TOKEN) ?>
        <?php if (($completed_message = get_transient(self::COMPLETE_CONFIG)) !== false) : ?>
            <div class="updated"><p><strong><?php echo esc_html($completed_message) ?></strong></p></div>
        <?php endif; ?>
        <?php if (($error_message = get_transient(self::ERROR_CONFIG)) !== false) : ?>
            <div class="error"><p><strong><?php echo esc_html($error_message) ?></strong></p></div>
        <?php endif; ?>
        <div class="updated" style="width: 800px;">
            <p>
                ご利用を開始するためのドキュメントをご確認ください。
            </p>
            <p>
                <a target="_blank" href="https://console.imageflux.jp/docs/wordpress">ドキュメント</a>
            </p>
        </div>
        <div>
            <div style="display: inline-block; vertical-align: top;">
                <p style="margin-top: 16px;">
                    <label for="api_token">システムAPIトークン：</label>
                </p>
            </div>
            <div style="display: inline-block;">
                <p>
                    <input type="text" id="api_token" name="api_token" data-name="APIトークン" value="<?php echo esc_attr($basic->get('api_token')) ?>" style="width: 600px;" required />
                </p>
                <p>
                    ImageFluxのシステムAPIトークンを設定してください。<br><a target="_blank" href="https://console.imageflux.jp/auth/login">ImageFlux管理コンソール</a>の右上にあるアカウント設定から取得できます。
                </p>
            </div>
        </div>
        <p><input type='submit' value='保存' class='button button-primary button-large'></p>
    </form>
</div>

<script>
    jQuery('input[name="kind"]').on('change', function () {
        let val = parseInt(jQuery(this).val());

        // HTTP
        if (val === 0) {
            jQuery('#s3_configs').hide();
            jQuery('#http_configs').show();
        }
        // S3
        if (val === 1) {
            jQuery('#http_configs').hide();
            jQuery('#s3_configs').show();
        }
    });

    // バリデーション
    jQuery('#origin-form').on('submit', function () {
        let all_required_keys = ['api_token'];

        let errors = [];

        // 全体
        jQuery.each(all_required_keys, function (index, key) {
            if (isValueEmpty(key)) {
                errors.push(jQuery('#' + key).data('name') + "は必須です。\n");
            }
        });

        if (errors.length > 0) {
            alert(errors.join(""));
            return false;
        }
    });

    function isValueEmpty(id)
    {
        return jQuery('#' + id).val() === "";
    }

</script>